package hikapro.com.backpack.model;

import java.util.List;

import hikapro.com.backpack.model.entities.Category;
import hikapro.com.backpack.model.entities.Item;
import hikapro.com.backpack.model.entities.Set;
import hikapro.com.backpack.presenter.Presenter;

/**
 * Created by tariel on 19/04/16.
 */
public interface Model {

    interface Base {
        void onDestroy(boolean isConfigurationChanging);
        void executeQuery();
        void sendMessage(String message);
    }

    interface Set extends Base {
        hikapro.com.backpack.model.entities.Set getSetByPosition(int position);
        hikapro.com.backpack.model.entities.Set findSet(int id);
        int getSetsCount();
        void notifyDataSetChanged();
        void setPresenter(Presenter.SetList presenter);
        Presenter.SetList getPresenter();

        //GLM
        List<hikapro.com.backpack.model.entities.Set> getSet();
    }

    interface Item extends Base {
        int insertItem(hikapro.com.backpack.model.entities.Item item);
        boolean deleteItem(int id);
        hikapro.com.backpack.model.entities.Item findItem(int id);
        hikapro.com.backpack.model.entities.Item getItemByPosition(int categoryId, int position);
        int getItemsCount(int categoryId);
        hikapro.com.backpack.model.entities.Category getCategoryByPosition(int position);
        int getCategoriesCount();
        void notifyDataSetChanged();
        void setPresenter(Presenter.ItemList presenter);
        Presenter.ItemList getPresenter();
    }
    interface Detail extends Base {
        int getCount();
        hikapro.com.backpack.model.entities.Item findItem(int id);
        void notifyDataSetChanged();
        void setPresenter(Presenter.ItemDetail presenter);
        Presenter.ItemDetail getPresenter();

    }

}
