package hikapro.com.backpack.model;

import java.util.ArrayList;
import java.util.List;

import hikapro.com.backpack.model.entities.Set;
import hikapro.com.backpack.presenter.Presenter;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

/**
 * Created by tariel on 20/04/16.
 */
public class SetModel implements Model.Set {

    private List<hikapro.com.backpack.model.entities.Set> iList;
    private Api                 api;
    private Presenter.SetList   presenter;

    public SetModel() {
        this.api            = RestClient.getApi();
        this.iList          = new ArrayList<>();
    }

    // sets -->

    @Override
    public hikapro.com.backpack.model.entities.Set getSetByPosition(int position) {
        return iList.get(position);
    }
    @Override
    public hikapro.com.backpack.model.entities.Set findSet(int id) {
        Set ret = null;
        for (Set s : iList) {
            if (s.getId() == id) {
                ret = s;
                break;
            }
        }
        return ret;
    }

    @Override
    public int getSetsCount() {
        return iList.size();
    }

    // sets <--

    // events -->

    @Override
    public void onDestroy(boolean isConfigurationChanging) {
        if ( !isConfigurationChanging ) {
            presenter = null;
        }

    }
    @Override
    public void notifyDataSetChanged() {
        presenter.notifyDataSetChanged();
    }

    @Override
    public void sendMessage(String message) {
        presenter.showMessage(message);
    }

    // events <--

    // process -->

    @Override
    public void executeQuery() {
        if (iList.isEmpty())
            loadSets();
        else
            notifyDataSetChanged();
    }

    private void loadSets() {
        Call<List<hikapro.com.backpack.model.entities.Set>> call = api.getSets();
        call.enqueue(new Callback<List<hikapro.com.backpack.model.entities.Set>>() {
            @Override
            public void onResponse(Call<List<hikapro.com.backpack.model.entities.Set>> call, Response<List<hikapro.com.backpack.model.entities.Set>> response) {
                int statusCode = response.code();
                iList = response.body();
                notifyDataSetChanged();
            }
            @Override
            public void onFailure(Call<List<hikapro.com.backpack.model.entities.Set>> call, Throwable t) {

            }
        });
    }
    private void syncData() {

    }
    // process <--

    // other -->

    @Override
    public void setPresenter(Presenter.SetList presenter) {
        this.presenter = presenter;
    }

    @Override
    public Presenter.SetList getPresenter() {
        return presenter;
    }

    // other <--


    //GLM

    @Override
    public List<hikapro.com.backpack.model.entities.Set> getSet()
    {
        return iList;
    }
}
