package hikapro.com.backpack.presenter.adapters;

import android.support.v7.widget.RecyclerView;
import android.view.ViewGroup;

import java.util.ArrayList;
import java.util.List;

import hikapro.com.backpack.presenter.Presenter;
import hikapro.com.backpack.view.recycler.CategoryViewHolder;

/**
 * Created by tariel on 20/04/16.
 */
public class CategoryListAdapter extends RecyclerView.Adapter<CategoryViewHolder> {

    private Presenter.ItemList presenter;
    private List<ItemListAdapter> itemAdapters;

    public CategoryListAdapter(Presenter.ItemList presenter) {
        this.presenter = presenter;
        this.itemAdapters = new ArrayList<>();
    }

    @Override
    public int getItemCount() {
        return presenter.getCategoriesCount();
    }

    @Override
    public void onBindViewHolder(CategoryViewHolder holder, int position) {
        presenter.bindViewHolderCategory(holder, position);
    }

    @Override
    public CategoryViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return presenter.createViewHolderCategory(parent, viewType);
    }

    public void addItemAdapter(ItemListAdapter adapter) {
        itemAdapters.add(adapter);
        adapter.notifyDataSetChanged();
    }
    public void notifyItemAdapters() {
        for (ItemListAdapter adapter : itemAdapters) {
            adapter.notifyDataSetChanged();
        }
    }

}
