package hikapro.com.backpack.view;

import android.content.Context;
import android.widget.Toast;

import hikapro.com.backpack.model.entities.Item;
import hikapro.com.backpack.model.entities.Set;
import hikapro.com.backpack.presenter.Presenter;
import hikapro.com.backpack.presenter.adapters.helper.OnStartDragListener;

/**
 * Created by tariel on 19/04/16.
 */
public interface View {

    interface Base {
        Context getAppContext();
        Context getActivityContext();
    }
    interface SetList extends Base {
        void showItemList(Set set);
        void setPresenter(Presenter.SetList presenter);

        //GLM_add_resources_SetList
        OnStartDragListener getOnStartDragListener();
    }

    interface ItemList extends Base {
        void showItemDetail(Item item);
        void setPresenter(Presenter.ItemList presenter);
        Set getSet();
    }
    interface ItemDetail extends Base {
        void setPresenter(Presenter.ItemDetail presenter);
        Item getItem();
    }
    interface ActivityCallback {
        void startSetListFragment();
        void startItemListFragment(Set set);
        void startItemDetailFragment(Item item);

    }
}
